table = []

case ARGV[0] 
when "UTF8"
  table_variable_name = "jisx0208_utf8_latin_table"
  def to_sdlskk_char(str)
    i = 0

    if str[0] & 0x80 == 0 then
      return str[0]
    else
      while ((0x80>>i)&str[0]) != 0 do
	i += 1
      end
      len = i
    end
    if len > 6 then
      return 0xFFFFFFFFF
    end

    result = (0xFF>>len) & str[0]
    for i in 1...len do
      result = ( result << 6 )|(str[i] & 0x3F )
    end
    result
  end
  
when "EUCJP"

  table_variable_name = "jisx0208_eucjp_latin_table"
  def to_sdlskk_char(str)
    if str[0] <= 0x7E then
      return str[0]
    end
    if str[0] >= 0xA0 && str[0] <=0xFF then
      return (str[0]<<8) + str[1]
    end
    if str[0] == 0x8E then
      return (str[0]<<8) + str[1]
    end
    if str[0] == 0x8F then
      return (str[0]<<16) + (str[1]<<8) + str[2];
    end
    return 0xFFFFFFFF
  end

when "SJIS"

  table_variable_name = "jisx0208_sjis_latin_table"
  def to_sdlskk_char(str)
    if str[0] <= 0x7E then
      return str[0]
    end
    if ( 0x81 <= str[0] && str[0] <= 0x9F ) ||
	( 0xE0 <= str[0] && str[0] <= 0xEF ) then
      return (str[0]<<8) + str[1]
    end
    return  0xFFFFFFFF
  end
  
else
  raise "give ARGV[0]"
end
ARGV.shift

while line = gets do
  next if "\t\n\0".include? line[0]
  key, str = line.split(/\t/)
  table[ key[0] ] = to_sdlskk_char(str)
end

print "static SDLSKK_Char #{table_variable_name}[128] = {"
for i in 0..127
  print table[i] || "0xFFFFFFFEUL" ,", "
end
print "};\n"

  
